#line 1 "C:/_MikroC/_MesProjets_MikroC/_18F2550_StartUSB/18F2550_test_UART_IT_ADC.c"
#line 59 "C:/_MikroC/_MesProjets_MikroC/_18F2550_StartUSB/18F2550_test_UART_IT_ADC.c"
sbit LED_Sup at LATA1_bit;
sbit LED_Inf at LATB1_bit;

unsigned char readbuff[128] absolute 0x500;
unsigned char writebuff[128] absolute 0x580;


unsigned int i,j,k;
char error;
char TEXTE[64];
char * txt;
char CRam1[18];

const unsigned long Poids [8]={268435456,16777216,1048576,65536,4096,256,16,1};
unsigned char Receive[9]="0000FFFF";
unsigned long Result;
float ff1;

unsigned char Buffer1[64];
volatile int Flag_Buffer1;
volatile unsigned char c1;
volatile unsigned int i1;
volatile int Index1;
volatile unsigned int CptErr1;

volatile unsigned int Count1;
volatile int Flag_Timer1;
volatile unsigned int Count2;
volatile int Flag_Timer2;
unsigned char *p1;


void Interrupts() iv 0x0008 ics ICS_AUTO
{
 if ( (RCIE_bit) && ( RCIF_bit))
 {

 if (RCSTA.OERR==1)
 {
 RCSTA.CREN = 0 ;
 c1 = RCREG;
 RCSTA.CREN = 1 ;
 CptErr1++;
 }
 if(RCSTA.FERR==1 )
 {
 RCSTA.SPEN = 0 ;
 RCSTA.SPEN= 1 ;
 CptErr1++;
 c1 = RCREG;
 }
 c1 = RCREG;
 if (c1== 13 )
 {
 Flag_Buffer1=1;

 Buffer1[i1]=0;
 Index1=i1;
 i1=0;
 c1=0;
 }
 else
 {
 Flag_Buffer1=0;
 Buffer1[i1]=c1;
 Index1=i1;
 i1++;

 }
 }

 if ( (TMR1IE_bit==1) && ( TMR1IF_bit==1))
 {

 Count1++;
 if (Count1>=8)
 {
 Count1=0;
 Flag_Timer1=1;
 TMR1IE_bit=0;
 }
 TMR1H= 0x0B;
 TMR1L= 0xDB;
 PIR1.TMR1IF=0;
 }
#line 159 "C:/_MikroC/_MesProjets_MikroC/_18F2550_StartUSB/18F2550_test_UART_IT_ADC.c"
 }



void Init_Timer1(void)
 {
 T1CON=0;
 T1CKPS1_bit=1;
 T1CKPS0_bit=1;

 TMR1H= 0x0B;
 TMR1L= 0xDB;


 Count1=0;
 Flag_Timer1=0;
 PIR1.TMR1IF=0;
 PIE1.TMR1IE=0;
 TMR1ON_bit=0;
}

 void Init_Timer2(void)
 {
 T2CON=0;
 TOUTPS0_bit=1;
 TOUTPS1_bit=1;
 TOUTPS2_bit=1;
 TOUTPS3_bit=1;
 T2CKPS1_bit=1;
 T2CKPS0_bit=1;
 TMR2= 60;
 Count2=0;
 Flag_Timer2=0;
 TMR2IF_bit=0;
 TMR2IE_bit=0;
 TMR2ON_bit=0;
}


void Float2Ascii (float x, unsigned char *str,char precision)
{


 int ie, i, k, ndig;
 double y;
 ndig = ( precision<=0) ? 7 : (precision > 22 ? 23 : precision+1);
 ie = 0;

 if ( x < 0)
 {
 *str++ = '-';
 x = -x;
 }

 if (x > 0.0) while (x < 1.0)
 {
 x *= 10.0;
 ie--;
 }
 while (x >= 10.0)
 {
 x = x/10.0;
 ie++;
 }

 ndig += ie;


 for (y = i = 1; i < ndig; i++)
 y = y/10.;
 x += y/2.;
 if (x >= 10.0) {x = 1.0; ie++;}
 if (ie<0)
 {
 *str++ = '0'; *str++ = '.';
 if (ndig < 0) ie = ie-ndig;
 for (i = -1; i > ie; i--) *str++ = '0';
 }
 for (i=0; i < ndig; i++)
 {
 k = x;
 *str++ = k + '0';
 if (i == ie ) *str++ = '.';
 x -= (y=k);
 x *= 10.0;
 }
 *str = '\0';
}


void CRLF()
{
UART1_Write( 13 );
UART1_Write( 10 );

}

void UART1_Write_CText(const char *T)
 {
 while (*T)
 UART1_Write(*T++);
}


unsigned long HexacarToLong( unsigned char *P)
 { unsigned char c;
 int i,k ;
 unsigned long L=0;
 k=strlen(P);
 if (k !=8)
 { UART1_Write_CText("\r\n Hexa sur 8 digits ! \r\n");
 return(0);
 }
 for(i=7;i>=0;i--)
 {
 c= toupper(*(P+i));

 if ((c>=65) && (c<=70))
 c=( c-65)+10;
 else
 {
 if ((c>=48) && (c<=57) )
 {
 c=c-48;
 }
 else
 {
 L=0;
 UART1_Write_CText("\r\nError sur Hexa \r\n");
 break;
 }
 }
 L= L + (Poids[i]* (unsigned long) c);
 }
 return L;
 }

void Raz_Buffer1()
{
 Buffer1[0]=0;
 c1=0;
 i1=0;
 Index1=0;
 Flag_Buffer1 =0;
 RCIF_bit=0;
 RCIE_bit = 1;
}


void main()
{


 OSCTUNE =0;



 OSCCON.SCS1=1;
 OSCCON.SCS0=0;

 OSCCON.IRCF2=1;
 OSCCON.IRCF1=1;
 OSCCON.IRCF0=1;

 Delay_ms(200);


 TRISA=0xFF;
 TRISA1_bit=0;
 TRISB=0xFF;
 TRISB1_bit=0;
 TRISC=0xFF; Delay_ms(200);
 Delay_ms(200);

 LED_Sup=0;
 LED_Inf=0;


 CMCON = 0x07;
 TEXTE[0]=0;
 txt=&TEXTE[0];

 Delay_ms(1000);

 UART1_Init(19200);
 Delay_ms(100);
 UART_Set_Active(&UART1_Read, &UART1_Write, &UART1_Data_Ready, &UART1_Tx_Idle);
 while (UART_Tx_Idle() == 0); UART1_Write(65);
 while (UART1_Tx_Idle() == 0);UART1_Write(66);
 while (UART1_Tx_Idle() == 0);UART1_Write(67);
 while (UART1_Tx_Idle() == 0);UART1_Write(13);
 while (UART1_Tx_Idle() == 0);UART1_Write(10);

 UART1_Write_CText("initialisation Pointeur sur zone TEXTE\r\n");

 Delay_ms(1000);
 UART1_Write_CText("StartUSB 18F2550 Init UART HARDW 19200 with FOSC Interne 8MHZ\r\n");



 ADCON0 = 0x00;

 ADCON1 = 0b00001110;
 ADCON1.VCFG1=0;
 ADCON1.VCFG0=0;
 ADCON1.PCFG3=1;
 ADCON1.PCFG2=1;
 ADCON1.PCFG1=1;
 ADCON1.PCFG0=0;


 ADCON2.ADFM=1;
 ADCON2.ACQT2=1;
 ADCON2.ACQT1=0;
 ADCON2.ACQT0=1;
 ADCON2.ADCS2=1;
 ADCON2.ADCS2=0;
 ADCON2.ADCS2=1;

 ADCON0.ADON = 1;
 Delay_ms(1);

 Init_Timer1();

 Raz_Buffer1();
 RCIE_bit=1;
 PEIE_bit=1;
 GIE_bit=1;


 while(1)
 {
 ADCON0.GO_DONE = 1;
 while(ADCON0.GO_DONE != 0);
 k = (ADRESH<<8) | ADRESL ;
 ff1=(float)k * 5.00/1024.0;

 Float2Ascii(ff1,CRam1,2);
 sprintf(txt,"ADC Results  k=% 5u Pts k=%04X soit %s Volts \r\n",k,k,CRam1);
 UART1_Write_Text(txt);
 if (k >522) LED_Sup=1; else LED_Sup=0;
 if (k <502) LED_Inf=1; else LED_Inf=0;



 if (Flag_Buffer1==1)
 {

 Result=HexacarToLong(&Buffer1[0]);
 LongWordToStrWithZeros (Result,CRam1);
 sprintf(txt,"Recu buffer1= %s, convertit en %s  soit %lu ",Buffer1,CRam1,Result);
 UART1_Write_Text(txt);
 CRLF();
 Raz_Buffer1();
 }
 Delay_ms(200);
 }
 }
